"""
Minizinc 2014 and 2015
"""

from pycsp3 import *

domains, costs, f2x, f2y, nTuples2, offsets2, t2, f3x, f3y, f3z, nTuples3, offsets3, t3 = data
n = len(domains)

# x[i] is the value for the ith variable
x = VarArray(size=n, dom=lambda i: domains[i])

satisfy(
    # binary constraints
    [(x[f2x[j]], x[f2y[j]]) in [(t2[2 * offsets2[j] + k * 2], t2[2 * offsets2[j] + k * 2 + 1]) for k in range(nTuples2[j])] for j in range(len(f2x))],

    # ternary constraints
    [(x[f3x[j]], x[f3y[j]], x[f3z[j]]) in [
        (t3[3 * offsets3[j] + k * 3], t3[3 * offsets3[j] + k * 3 + 1], t3[3 * offsets3[j] + k * 3 + 2]) for k in range(nTuples3[j])] for j in range(len(f3x))]
)

if not variant():
    minimize(
        Sum(costs[i] * (x[i] == 0) for i in range(n))
    )

elif variant("mini"):
    y = VarArray(size=n, dom={0, 1})

    satisfy(
        (y[i], x[i]) in {(0, ne(0)), (1, 0)} for i in range(n)
    )

    minimize(
        y * costs
    )
