"""
This problem is taken from Daily Telegraph and Sunday Times,
and used in Minizinc Competitions (2015 and 2019) with data
   10, 16, 22, 28 37 in 2015
   10, 17, 23, 29 37 in 2019

The problem is to find, for an equilateral triangular grid of size n (length of a side),
the maximum number of nodes that can be selected without having all selected corners of any equilateral triangle
of any size or orientation.
"""

from pycsp3 import *

n = data

# x[i,j] is 1 iff the jth node in the ith row is selected
x = VarArray(size=[n, n], dom=lambda i, j: {0, 1} if i >= j else None)

satisfy(
    Sum(x[i + m][j], x[i + k][j + m], x[i + k - m][j + k - m]) <= 2 for i in range(n) for j in range(i + 1) for k in range(1, n - i) for m in range(k)
)

maximize(
    Sum(x)
)
