"""
Problem 080 on CSPLib
"""

from pycsp3 import *

n, blocks = data

# q[i] is the column where is put the ith queen (at row i)
q = VarArray(size=n, dom=range(n))

satisfy(
    # respecting blocks
    [q[i] != j for (i, j) in blocks],

    # no two queens on the same column
    AllDifferent(q),

    # no two queens on the same diagonal
    [abs(q[i] - q[j]) != abs(i - j) for i, j in combinations(n, 2)]
)

# # controlling no two queens on the same upward diagonal
# AllDifferent(q[i] + i for i in range(n)),
#
# # controlling no two queens on the same downward diagonal
# AllDifferent(q[i] - i for i in range(n)),
