"""
See https://en.wikipedia.org/wiki/Hidato
    http://www.hidato.com/

    8,8 9,9, 10,10
    9 et 10
"""

from pycsp3 import *

n, m, puzzle = data

x = VarArray(size=[n, m], dom=range(1, n * m + 1))

satisfy(
    AllDifferent(x),

    [x[i][j] == puzzle[i][j] for i in range(n) for j in range(m) if puzzle and puzzle[i][j] > 0]
)

if not variant():
    satisfy(
        (x[i, j] == n * m) | (Count(x.around(i, j), value=x[i, j] + 1) == 1) for i in range(n) for j in range(m)
    )

elif variant('table'):
    def table(i, j):
        r = 3 if (i, j) in {(0, 0), (0, m - 1), (n - 1, 0), (n - 1, m - 1)} else 5 if i in (0, n - 1) or j in (0, m - 1) else 8
        return [tuple([v] + [v + 1 if kk == k else ANY for kk in range(r)]) for v in range(1, n * m) for k in range(r)] + [tuple([n * m] + [ANY] * r)]


    satisfy(
        (x[i, j], x.around(i, j)) in table(i, j) for i in range(n) for j in range(m)
    )
